import { ExtractorPlugin, Playlist, Song } from "distube";
import type { GuildMember } from "discord.js";
export declare class SoundCloudPlugin extends ExtractorPlugin {
    /**
     * Search for tracks/playlists on SoundCloud
     * @param {string} query String query
     * @param {'track'|'playlist'} [type='track'] type
     * @param {number} [limit=10] limit
     * @returns {Array<Song|Playlist>}
     */
    static search(query: string, type?: string, limit?: number): Promise<Song[] | (Playlist | undefined)[]>;
    /**
     * Search for tracks/playlists on SoundCloud
     * @param {string} query String query
     * @param {'track'|'playlist'} [type='track'] type
     * @param {number} [limit=10] limit
     * @returns {Array<Song|Playlist>}
     */
    search(query: string, type?: string, limit?: number): Promise<Song[] | (Playlist | undefined)[]>;
    validate(url: string): Promise<boolean>;
    resolve(url: string, member: GuildMember): Promise<Song | Playlist>;
    getRelatedSongs(url: string | number): Promise<Song[]>;
    getStreamURL(url: string): Promise<string>;
}
export default SoundCloudPlugin;
//# sourceMappingURL=index.d.ts.map